import { useEffect, useState } from "react";
import AMapLoader from "@amap/amap-jsapi-loader";
import MapUtl from "./mapUtil";

export default function MapContainer() {
  let [amap, setmaps] = useState<any>(null);
  useEffect(() => {
    loadMaps();
    return () => {
      amap?.destroy();
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  const loadMaps = async () => {
    const Amap = await AMapLoader.load({
      key: "d58999d072ed7e5897d3900a769cfda0", // 申请好的Web端开发者Key，首次调用 load 时必填
      version: "2.0", // 指定要加载的 JSAPI 的版本，缺省时默认为 1.4.15
      plugins: ["AMap.Scale"],
    });

    amap = new Amap.Map("container", {
      viewMode: "2D", // 是否为3D地图模式
      zoom: 11, // 初始化地图级别
      center: [103.55, 30.34], // 初始化地图中心点位置
      mapStyle: "amap://styles/darkblue",
      resizeEnable: true,
    });
    setmaps(amap);
    addMaket(Amap,amap);
    amap.setFitView();
  };
  const addMaket = (m,mp) => {
    const marker = new m.Marker({
      position: new m.LngLat(103.55, 30.34),
      title: "黄水",
    });
   
    var content = [
      "<div><b>高德软件有限公司</b>",
      "电话 : 010-84107000   邮编 : 100102",
      "地址 : 北京市望京阜通东大街方恒国际中心A座16层</div>",
    ];
    var infoWindow = new m.InfoWindow({
      offset: new m.Pixel(0, -30),
      autoMove: true,
      content: content.join("<br/>"),
    });
    marker.on("click", (e) => {
      infoWindow.open(mp, e.target.getPosition());
    });
    amap.add(marker);

    MapUtl.makerList.push(marker);
    MapUtl.amap = m;
  };

  return <div id="container" style={{ height: "100vh" }}></div>;
}
